git-svn: hide find_parent_branch output in double quiet mode
[git/dscho.git] / git-rebase.sh
blob6ec155cf03c98f2e075f298039037d0e099311b1
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 OK_TO_SKIP_PRE_REBASE=
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest="$GIT_DIR"/rebase-merge
47 prec=4
48 verbose=
49 diffstat=$(git config --bool rebase.stat)
50 git_am_opt=
51 rebase_root=
52 force_rebase=
54 continue_merge () {
55 test -n "$prev_head" || die "prev_head must be defined"
56 test -d "$dotest" || die "$dotest directory does not exist"
58 unmerged=$(git ls-files -u)
59 if test -n "$unmerged"
60 then
61 echo "You still have unmerged paths in your index"
62 echo "did you forget to use git add?"
63 die "$RESOLVEMSG"
66 cmt=`cat "$dotest/current"`
67 if ! git diff-index --quiet --ignore-submodules HEAD --
68 then
69 if ! git commit --no-verify -C "$cmt"
70 then
71 echo "Commit failed, please do not call \"git commit\""
72 echo "directly, but instead do one of the following: "
73 die "$RESOLVEMSG"
75 if test -z "$GIT_QUIET"
76 then
77 printf "Committed: %0${prec}d " $msgnum
79 else
80 if test -z "$GIT_QUIET"
81 then
82 printf "Already applied: %0${prec}d " $msgnum
85 if test -z "$GIT_QUIET"
86 then
87 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
90 prev_head=`git rev-parse HEAD^0`
91 # save the resulting commit so we can read-tree on it later
92 echo "$prev_head" > "$dotest/prev_head"
94 # onto the next patch:
95 msgnum=$(($msgnum + 1))
96 echo "$msgnum" >"$dotest/msgnum"
99 call_merge () {
100 cmt="$(cat "$dotest/cmt.$1")"
101 echo "$cmt" > "$dotest/current"
102 hd=$(git rev-parse --verify HEAD)
103 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
104 msgnum=$(cat "$dotest/msgnum")
105 end=$(cat "$dotest/end")
106 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
107 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
108 export GITHEAD_$cmt GITHEAD_$hd
109 if test -n "$GIT_QUIET"
110 then
111 export GIT_MERGE_VERBOSITY=1
113 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
114 rv=$?
115 case "$rv" in
117 unset GITHEAD_$cmt GITHEAD_$hd
118 return
121 git rerere
122 die "$RESOLVEMSG"
125 echo "Strategy: $rv $strategy failed, try another" 1>&2
126 die "$RESOLVEMSG"
129 die "Unknown exit code ($rv) from command:" \
130 "git-merge-$strategy $cmt^ -- HEAD $cmt"
132 esac
135 move_to_original_branch () {
136 test -z "$head_name" &&
137 head_name="$(cat "$dotest"/head-name)" &&
138 onto="$(cat "$dotest"/onto)" &&
139 orig_head="$(cat "$dotest"/orig-head)"
140 case "$head_name" in
141 refs/*)
142 message="rebase finished: $head_name onto $onto"
143 git update-ref -m "$message" \
144 $head_name $(git rev-parse HEAD) $orig_head &&
145 git symbolic-ref HEAD $head_name ||
146 die "Could not move back to $head_name"
148 esac
151 finish_rb_merge () {
152 move_to_original_branch
153 rm -r "$dotest"
154 say All done.
157 is_interactive () {
158 while test $# != 0
160 case "$1" in
161 -i|--interactive)
162 interactive_rebase=explicit
163 break
165 -p|--preserve-merges)
166 interactive_rebase=implied
168 esac
169 shift
170 done
172 if [ "$interactive_rebase" = implied ]; then
173 GIT_EDITOR=:
174 export GIT_EDITOR
177 test -n "$interactive_rebase" || test -f "$dotest"/interactive
180 run_pre_rebase_hook () {
181 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
182 test -x "$GIT_DIR/hooks/pre-rebase"
183 then
184 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
185 die "The pre-rebase hook refused to rebase."
189 test -f "$GIT_DIR"/rebase-apply/applying &&
190 die 'It looks like git-am is in progress. Cannot rebase.'
192 is_interactive "$@" && exec git-rebase--interactive "$@"
194 if test $# -eq 0
195 then
196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
197 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
198 die 'A rebase is in progress, try --continue, --skip or --abort.'
199 die "No arguments given and $GIT_DIR/rebase-apply already exists."
202 while test $# != 0
204 case "$1" in
205 --no-verify)
206 OK_TO_SKIP_PRE_REBASE=yes
208 --continue)
209 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
210 die "No rebase in progress?"
212 git diff-files --quiet --ignore-submodules || {
213 echo "You must edit all merge conflicts and then"
214 echo "mark them as resolved using git add"
215 exit 1
217 if test -d "$dotest"
218 then
219 prev_head=$(cat "$dotest/prev_head")
220 end=$(cat "$dotest/end")
221 msgnum=$(cat "$dotest/msgnum")
222 onto=$(cat "$dotest/onto")
223 GIT_QUIET=$(cat "$dotest/quiet")
224 continue_merge
225 while test "$msgnum" -le "$end"
227 call_merge "$msgnum"
228 continue_merge
229 done
230 finish_rb_merge
231 exit
233 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
234 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
235 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
236 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
237 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
238 move_to_original_branch
239 exit
241 --skip)
242 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
243 die "No rebase in progress?"
245 git reset --hard HEAD || exit $?
246 if test -d "$dotest"
247 then
248 git rerere clear
249 prev_head=$(cat "$dotest/prev_head")
250 end=$(cat "$dotest/end")
251 msgnum=$(cat "$dotest/msgnum")
252 msgnum=$(($msgnum + 1))
253 onto=$(cat "$dotest/onto")
254 GIT_QUIET=$(cat "$dotest/quiet")
255 while test "$msgnum" -le "$end"
257 call_merge "$msgnum"
258 continue_merge
259 done
260 finish_rb_merge
261 exit
263 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
264 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
265 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
266 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
267 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
268 move_to_original_branch
269 exit
271 --abort)
272 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
273 die "No rebase in progress?"
275 git rerere clear
276 if test -d "$dotest"
277 then
278 GIT_QUIET=$(cat "$dotest/quiet")
279 move_to_original_branch
280 else
281 dotest="$GIT_DIR"/rebase-apply
282 GIT_QUIET=$(cat "$dotest/quiet")
283 move_to_original_branch
285 git reset --hard $(cat "$dotest/orig-head")
286 rm -r "$dotest"
287 exit
289 --onto)
290 test 2 -le "$#" || usage
291 newbase="$2"
292 shift
294 -M|-m|--m|--me|--mer|--merg|--merge)
295 do_merge=t
297 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
298 --strateg=*|--strategy=*|\
299 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
300 case "$#,$1" in
301 *,*=*)
302 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
303 1,*)
304 usage ;;
306 strategy="$2"
307 shift ;;
308 esac
309 do_merge=t
311 -n|--no-stat)
312 diffstat=
314 --stat)
315 diffstat=t
317 -v|--verbose)
318 verbose=t
319 diffstat=t
320 GIT_QUIET=
322 -q|--quiet)
323 GIT_QUIET=t
324 git_am_opt="$git_am_opt -q"
325 verbose=
326 diffstat=
328 --whitespace=*)
329 git_am_opt="$git_am_opt $1"
330 case "$1" in
331 --whitespace=fix|--whitespace=strip)
332 force_rebase=t
334 esac
336 --ignore-whitespace)
337 git_am_opt="$git_am_opt $1"
339 --committer-date-is-author-date|--ignore-date)
340 git_am_opt="$git_am_opt $1"
341 force_rebase=t
343 -C*)
344 git_am_opt="$git_am_opt $1"
346 --root)
347 rebase_root=t
349 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase)
350 force_rebase=t
353 usage
356 break
358 esac
359 shift
360 done
361 test $# -gt 2 && usage
363 # Make sure we do not have $GIT_DIR/rebase-apply
364 if test -z "$do_merge"
365 then
366 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
367 then
368 rmdir "$GIT_DIR"/rebase-apply
369 else
370 echo >&2 '
371 It seems that I cannot create a rebase-apply directory, and
372 I wonder if you are in the middle of patch application or another
373 rebase. If that is not the case, please
374 rm -fr '"$GIT_DIR"'/rebase-apply
375 and run me again. I am stopping in case you still have something
376 valuable there.'
377 exit 1
379 else
380 if test -d "$dotest"
381 then
382 die "previous rebase directory $dotest still exists." \
383 'Try git rebase (--continue | --abort | --skip)'
387 # The tree must be really really clean.
388 if ! git update-index --ignore-submodules --refresh > /dev/null; then
389 echo >&2 "cannot rebase: you have unstaged changes"
390 git diff-files --name-status -r --ignore-submodules -- >&2
391 exit 1
393 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
394 case "$diff" in
395 ?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
396 echo >&2 "$diff"
397 exit 1
399 esac
401 if test -z "$rebase_root"
402 then
403 # The upstream head must be given. Make sure it is valid.
404 upstream_name="$1"
405 shift
406 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
407 die "invalid upstream $upstream_name"
408 unset root_flag
409 upstream_arg="$upstream_name"
410 else
411 test -z "$newbase" && die "--root must be used with --onto"
412 unset upstream_name
413 unset upstream
414 root_flag="--root"
415 upstream_arg="$root_flag"
418 # Make sure the branch to rebase onto is valid.
419 onto_name=${newbase-"$upstream_name"}
420 onto=$(git rev-parse --verify "${onto_name}^0") || exit
422 # If a hook exists, give it a chance to interrupt
423 run_pre_rebase_hook "$upstream_arg" "$@"
425 # If the branch to rebase is given, that is the branch we will rebase
426 # $branch_name -- branch being rebased, or HEAD (already detached)
427 # $orig_head -- commit object name of tip of the branch before rebasing
428 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
429 switch_to=
430 case "$#" in
432 # Is it "rebase other $branchname" or "rebase other $commit"?
433 branch_name="$1"
434 switch_to="$1"
436 if git show-ref --verify --quiet -- "refs/heads/$1" &&
437 branch=$(git rev-parse -q --verify "refs/heads/$1")
438 then
439 head_name="refs/heads/$1"
440 elif branch=$(git rev-parse -q --verify "$1")
441 then
442 head_name="detached HEAD"
443 else
444 usage
448 # Do not need to switch branches, we are already on it.
449 if branch_name=`git symbolic-ref -q HEAD`
450 then
451 head_name=$branch_name
452 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
453 else
454 head_name="detached HEAD"
455 branch_name=HEAD ;# detached
457 branch=$(git rev-parse --verify "${branch_name}^0") || exit
459 esac
460 orig_head=$branch
462 # Now we are rebasing commits $upstream..$branch (or with --root,
463 # everything leading up to $branch) on top of $onto
465 # Check if we are already based on $onto with linear history,
466 # but this should be done only when upstream and onto are the same.
467 mb=$(git merge-base "$onto" "$branch")
468 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
469 # linear history?
470 ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
471 then
472 if test -z "$force_rebase"
473 then
474 # Lazily switch to the target branch if needed...
475 test -z "$switch_to" || git checkout "$switch_to"
476 say "Current branch $branch_name is up to date."
477 exit 0
478 else
479 say "Current branch $branch_name is up to date, rebase forced."
483 # Detach HEAD and reset the tree
484 say "First, rewinding head to replay your work on top of it..."
485 git checkout -q "$onto^0" || die "could not detach HEAD"
486 git update-ref ORIG_HEAD $branch
488 if test -n "$diffstat"
489 then
490 if test -n "$verbose"
491 then
492 echo "Changes from $mb to $onto:"
494 # We want color (if set), but no pager
495 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
498 # If the $onto is a proper descendant of the tip of the branch, then
499 # we just fast forwarded.
500 if test "$mb" = "$branch"
501 then
502 say "Fast-forwarded $branch_name to $onto_name."
503 move_to_original_branch
504 exit 0
507 if test -n "$rebase_root"
508 then
509 revisions="$onto..$orig_head"
510 else
511 revisions="$upstream..$orig_head"
514 if test -z "$do_merge"
515 then
516 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
517 $root_flag "$revisions" |
518 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
519 move_to_original_branch
520 ret=$?
521 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
522 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
523 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
524 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
525 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
526 exit $ret
529 # start doing a rebase with git-merge
530 # this is rename-aware if the recursive (default) strategy is used
532 mkdir -p "$dotest"
533 echo "$onto" > "$dotest/onto"
534 echo "$onto_name" > "$dotest/onto_name"
535 prev_head=$orig_head
536 echo "$prev_head" > "$dotest/prev_head"
537 echo "$orig_head" > "$dotest/orig-head"
538 echo "$head_name" > "$dotest/head-name"
539 echo "$GIT_QUIET" > "$dotest/quiet"
541 msgnum=0
542 for cmt in `git rev-list --reverse --no-merges "$revisions"`
544 msgnum=$(($msgnum + 1))
545 echo "$cmt" > "$dotest/cmt.$msgnum"
546 done
548 echo 1 >"$dotest/msgnum"
549 echo $msgnum >"$dotest/end"
551 end=$msgnum
552 msgnum=1
554 while test "$msgnum" -le "$end"
556 call_merge "$msgnum"
557 continue_merge
558 done
560 finish_rb_merge